// Citaj.java - itanje podataka standardnih tipova iz ulaznog toka,
//              iz datoteke i s glavnog ulaza.

import  java.io.*;
import  java.util.Scanner;

public class Citaj {

  private Scanner skn;       // Skener itanog teksta.

  public Citaj(InputStream ut) { skn = new Scanner(ut); }// Inicijalizacija
                                                         //   ulaznim tokom.
  public Citaj(String ime) throws FileNotFoundException  // Inicijalizacija
    { skn = new Scanner(new FileInputStream(ime)); }     //   datotekom.
  
  public byte   ByteS    ()  // itanje jednog podatka tipa byte.
    { return skn.nextByte(); }

  public short  ShortS   ()  // itanje jednog podatka tipa short.
    { return skn.nextShort(); }

  public int    IntS     ()  // itanje jednog podatka tipa int.
    { return skn.nextInt(); }

  public long   LongS    ()  // itanje jednog podatka tipa long.
    { return skn.nextLong(); }

  public float  FloatS   ()  // itanje jednog podatka tipa float.
    { return skn.nextFloat(); }

  public double DoubleS  ()  // itanje jednog podatka tipa double.
    { return skn.nextDouble(); }

  public boolean BooleanS()  // itanje jednog podatka tipa boolean.
    { return skn.nextBoolean(); }

  public char CharS()        // itanje sledeeg nebelog znaka (proita se
    { return skn.next().charAt(0); }  //   cela re!).

  public String StringS()    // itanje jedne rei.
    { return skn.next(); }

  public String LineS()      // itanje jednog reda teksta.
    { return skn.nextLine(); }

  public boolean endS() { return !skn.hasNext(); }  // Da li je kraj toka?

  // PODRKA ZA ITANJE S GLAVNOG ULAZA.

  private static Citaj gl = new Citaj(System.in);   // Predstavnik
                                                     //   glavnog ulaza.
  public static byte    Byte   () { return gl.ByteS   (); } // Varijante
  public static short   Short  () { return gl.ShortS  (); } //   koje itaju
  public static int     Int    () { return gl.IntS    (); } //   sa glavnog
  public static long    Long   () { return gl.LongS   (); } //   ulaza.
  public static float   Float  () { return gl.FloatS  (); }
  public static double  Double () { return gl.DoubleS (); }
  public static boolean Boolean() { return gl.BooleanS(); }
  public static char    Char   () { return gl.CharS   (); }
  public static String  String () { return gl.StringS (); }
  public static String  Line   () { return gl.LineS   (); }
  public static boolean end    () { return gl.endS    (); }
}