// Crtanje na komponentama (Crtanje).

import java.awt.*;
import java.awt.event.*;

public class Crtanje extends Frame {
  private Crtanje() {                            // Parametri prozora:
    super("Crtanje na komponentama");            // - naslov prozora,
    setBounds(100, 100, 300, 160);               // - poloaj i veliina,
    addWindowListener(new WindowAdapter() {      // - oslukiva za dogaa-
      @Override                                  //   je prozora:
      public void windowClosing(WindowEvent dog)
        { dispose(); }                           //   ~ unitavanju prozo-
    });                                          //     ra.

    Panel plo = new Panel() {                    // Ploa po kojoj se crta:
      @Override
      public void paint(Graphics g) {            // - metoda za crtanje:
        g.setColor(Color.YELLOW);                //   ~ postavljanje boje,
        g.fillOval(10, 10, getWidth()-20,        //   ~ crtanje popunjene
                           getHeight()-20);      //     elipse;
      }
    };
    add(plo);                                    // - dodavanje prozoru.
    
    Button dgm1 = new Button("Dugme1") {         // Dugme iji se natpis
      @Override                                  // uokviruje:
      public void paint(Graphics g) {            // - metoda za crtanje:
        g.setColor(Color.RED);                   //   ~ postavljanje boje,
        g.drawRect(3, 3, getWidth()-7,           //   ~ crtanje pravougao-
                         getHeight()-7);         //     nog okvira oko nat-
      }                                          //     pisa;
    };
    plo.add(dgm1);                               // - dodavanje ploi.

    Button dgm2 = new Button("Dugme2") {         // Dugme iji se natpis
      @Override                                  // pokriva:
      public void paint(Graphics g) {            // - metoda za crtanje;
        g.setColor(Color.GREEN);                 //   ~ postavljanje boje,
        g.fillRect(3, 3, getWidth()-6,           //   ~ crtanje popunjenog
                         getHeight()-6);         //     pravougaonika preko
      }                                          //     natpisa;
    };
    plo.add(dgm2);                               // - dodavanje ploi.
  }
  
  public static void main(String[] varg)         // Glavna metoda.
    { new Crtanje().setVisible(true); }
}
