// Definicija klase prozora s komponentama (Komponente).

import java.awt.*;
import java.awt.event.*;

public class Komponente extends Frame {
  private String[] vrs = {"Dialog",              // Koriene vrste slova.
        "DialogInput", "Monospaced", "Serif", "SansSerif"};
    
  private Komponente() {                         // Parametri prozora:
    super("Upotreba komponenata");               // - naslov,
    setSize(400, 150);                           // - dimenzije,
    setResizable(false);                         // - bez menjanja veliine
    addWindowListener(new WindowAdapter() {      // - oslukiva za unita-
      @Override                                  //   vanje prozora.
      public void windowClosing(WindowEvent dog)
        { dispose(); }
    });
    
    Label ntp = new Label("Danas je divan dan!", // Objekat natpisa:
                          Label.CENTER);         // - centriran,
    add(ntp, "Center");                          // - dodavanje prozoru.
    
    ActionListener osl = new ActionListener() {  // Oslukiva za dugmad:
      @Override
      public void actionPerformed(ActionEvent dog) {
        Button dgm = (Button)dog.getSource();    // - pritisnuto dugme,
        String vrs = dgm.getLabel();             // - natpis dugmeta,
        Font fnt = new Font(vrs, Font.BOLD, 20); // - font odabrane vrste,
        ntp.setFont(fnt);                        // - menjanje fonta objek-
      }                                          //   tu natpisa.
    };
    
    Panel plo = new Panel();                     // Ploa za dugmad:
    add(plo, "South");                           // - dodavanje prozoru.
    
    for (String v: vrs) {                        // Stvaranje dugmadi:
      Button dgm = new Button(v);                // - sledee dugme,
      plo.add(dgm);                              // - dodavanje ploi,
      dgm.addActionListener(osl);                // - postavljanje osluki-
    }                                            //   vaa.
    
    setVisible(true);                            // Neka prozor bude vid-
  }                                              //   ljiv.
  
  public static void main(String[] varg)         // Glavna metoda:
    { new Komponente(); }                        // - stvaranje objekta
}                                                //   svoje klase.
