// Definicija klase materijalnih taaka (MatTaka).

class MatTaka {
  private static MatTaka prva = null,          // Poetak i kraj liste
                          posl = null;          //   svih taaka.
  private MatTaka sled = null;                 // Sledea taka u listi.
  private double x, y, z;                       // Koordinate take.
  private double m;                             // Masa take.
  
  public static boolean ima(double x, double y, // Da li ve postoji
                            double z) {         //   u listi?
    for (MatTaka tek=prva; tek!=null; tek=tek.sled)
      if (x==tek.x && y==tek.y && z==tek.z) return true;
    return false;
  }
  
  public MatTaka(double x, double y, double z, // Inicijalizacija
                  double m) {                   //   novog objekta.
    if (ima(x, y, z)) System.exit(1);
    this.x = x; this.y = y; this.z = z; this.m = m;
    if (prva == null) prva = this; else posl.sled = this;
    posl = this;
  }
  
  public MatTaka() { this(0, 0, 0, 1); }       // Podrazumevana taka.
  
  public static double r(MatTaka mt1,          // Rastojanje izmeu 
                         MatTaka mt2) {        //   dve take.
    return Math.sqrt(Math.pow(mt1.x-mt2.x,2) +
                     Math.pow(mt1.y-mt2.y,2) +
                     Math.pow(mt1.z-mt2.z,2)  );
  }
  
  public static double F(MatTaka mt1, MatTaka mt2) // Sila privlaenja.
    { return 6.67e-11 * mt1.m * mt2.m / Math.pow(r(mt1,mt2), 2); }
  
  public String toString()               // Tekstualni opis take.
    { return "[" + x + "," + y + "," + z + "|" + m + "]"; }
  
  public static String sve() {           // Tekstualni opis svih taaka.
    String s = "";
    for (MatTaka tek=prva; tek!=null; tek=tek.sled)
      s += tek + "\n";
    return s;
  } 
}
