// Definicija klase prozora s menijem (Meni).

import java.awt.*;
import java.awt.event.*;

public class Meni extends Frame {
  private String[] vrs = {"Dialog",              // Koriene vrste slova.
      "DialogInput", "Monospaced", "Serif", "SansSerif"};

  private Meni() {                               // Parametri prozora:
    super("Upotreba menija");                    // - naslov,
    setSize(400, 100);                           // - dimenzije,
    setResizable(false);                         // - bez menjanja veliine
    addWindowListener(new WindowAdapter() {      // - oslukiva za unita-
      @Override                                  //   vanje prozora.
      public void windowClosing(WindowEvent dog)
        { dispose(); }
    });
    
    Label ntp = new Label("Danas je divan dan!", // Objekat natpisa:
                          Label.CENTER);         // - centriran,
    add(ntp, "Center");                          // - dodavanje prozoru.
    
    ActionListener osl = new ActionListener() {  // Oslukiva za stavke
      @Override                                  //   menija:
      public void actionPerformed(ActionEvent dog) {
        MenuItem stv = (MenuItem)dog.getSource();// - pritisnuta stavka,
        String vrs = stv.getLabel();             // - natpis stavke,
        Font fnt = new Font(vrs, Font.BOLD, 20); // - font odabrane vrste,
        ntp.setFont(fnt);                        // - menjanje fonta objek-
      }                                          //   ta natpisa.
    };
    
    MenuBar traka = new MenuBar();               // Traka menija:
    setMenuBar(traka);                           // - dodavanje prozoru.
    
    Menu meni = new Menu("Slova");               // Meni:
    traka.add(meni);                             //- dodavanje traci.
    
    for (String v: vrs) {                        // Stvaranje stavki:
      MenuItem stavka = new MenuItem(v);         // - sledea stavka,
      meni.add(stavka);                          // - dodavanje meniju,
      stavka.addActionListener(osl);             // - postavljanje osluki-
    }                                            //   vaa.
    
    setVisible(true);                            // Neka prozor bude vid-
  }                                              //   ljiv.
  
  public static void main(String[] varg)         // Glavna metoda:
    { new Meni(); }                              // - stvaranje objekta
}                                                //   svoje klase.
