// Definicija klase nizova celih brojeva (Niz).

import usluge.Uslov;

public class Niz {
  private int[] niz;                      // Niz celih brojeva.
  private int n = 0;                      // Broj popunjenih mesta.
  
  public Niz(int k)                       // Stvaranje niza.
    { niz = new int[k]; }
  
  public Niz() { this(10); }
  
  public int kap() { return niz.length; } // Kapacitet niza.
  
  public int du() { return n; }          // Duina niza.
  
  public boolean dodaj(int broj) {        // Dodavanje broja.
    if (n == niz.length) return false;
    niz[n++] = broj; return true;
  }
  
  public int izostavi(Uslov usl) {    // Izostavljanje odabranih elemenata.
    int k = 0, j = 0;
    for (int i=0; i<n; i++)
      if (usl.uslov(niz[i])) k++;
        else niz[j++] = niz[i];
    n = j;
    return k;
  }
  
  @Override
  public String toString() {          // Sastavljanje tekstualnog opisa.
    String s = "";
    for (int i=0; i<n; i++)
      s += String.format("%4d", niz[i]);
    return s;
  }
}
