// Program za ispitivanje generike klase za nizove figura.

import ravan.Taka;
import figure.*;
import nizFigura.*;

public class NizFiguraTest {
  public static void main(String[] varg) {
    try {
      System.out.println("--- NIZ FIGURA -------------------------");
      var niz1 = new NizFigura<Figura>(5);
      niz1.dodaj(new Krug(10, new Taka(0,0)))
          .dodaj(new Kvadrat(3, new Taka(1, 1)))
          .dodaj(new Trougao(3, 4, 5, new Taka(7, 2)))
          .dodaj(new Krug(33, new Taka(-2,-4)))
          .dodaj(new Trougao(3, 5, 5, new Taka(7, -2)));
      java.util.Iterator<Figura> iter = niz1.iterator();
      while (iter.hasNext()) System.out.println(iter.next());
      System.out.println();
      Figura fig1 = niz1.dohvati(0);
      System.out.println("Prva figura u nizu:\n" + fig1);
      System.out.println("Ukupna povrina  : " + niz1.ukP());
      System.out.println("Broj figura P<100: " + niz1.broj(f->f.P()<100));
      System.out.println("Broj krugova     : " + 
                                         niz1.broj(f->f instanceof Krug));
      System.out.println("\nPo nerastuem redosledu obima:");
      System.out.println(niz1.uredi((a,b)->a.O()>b.O()));
      
      System.out.println("--- NIZ KRUGOVA ------------------------");
      var niz2 = new NizFigura<Krug>(5);
      niz2.dodaj(new Krug(10, new Taka(0,0)))
          .dodaj(new Krug(33, new Taka(-2,-4)));
      for (Figura f: niz2) System.out.println(f);
      System.out.println();
      Krug fig2 = niz2.dohvati(0);
      System.out.println("Prvi krug u nizu:\n" + fig2);
      System.out.println("Ukupna povrina  : " + niz2.ukP());
      System.out.println("Broj figura P<100: " + niz2.broj(f->f.P()<100));
      System.out.println("Broj krugova     : " + 
                                         niz2.broj(f->f instanceof Krug));
      System.out.println("\nPo nerastuem redosledu obima:");
      System.out.println(niz2.uredi((a,b)->a.O()>b.O()));
    } catch (GreNizPun | GreIndeks g) {}
  }
}
