// Definicija klase nizova taaka u ravni (NizTaka).

class NizTaaka {
  private Taka1[] take;                   // Niz taaka.
  private int brTa = 0;                    // Broj taaka u nizu.
  
  public NizTaaka(int kap)                 // Inicijalizacija objekta.
    { take = new Taka1 [kap]; }

  public int brojTaaka() { return brTa; } // Broj taaka u nizu.
  
  public boolean dodaj(Taka1 t) {          // Dodavanje take nizu.
    if (brTa == take.length) return false;
    take[brTa++] = t;
    return true;
  }
  
  public Taka1 dohvati(int ind) {          // Pristup taki u nizu.
    if (ind<0 || ind>=brTa) return null;
    return take[ind];
  }
  
  public Taka1 izvadi(int ind) {           // Vaenje take iz niza.
    if (ind<0 || ind>=brTa) return null;
    Taka1 t = take[ind];
    for (int i=ind; i<brTa-1; take[i]=take[++i]);
    take[--brTa] = null;
    return t;
  }
  
  public String toString() {                // Tekstualni opis niza.
    String s = "";
    for (int i=0; i<brTa; s+=take[i++]+" ");
    return s;
  }
  
  public static void main(String[] varg) {  // Glavna metoda.
    var skn = new java.util.Scanner(System.in);
    System.out.print("Broj taaka? ");
    NizTaaka nt = new NizTaaka(skn.nextInt());
    System.out.print("Niz taaka? ");
    for (int i=0; i<nt.brojTaaka(); i++) 
      { Taka1 t = new Taka1(); t.itaj(skn); nt.dodaj(t); }
    double z = 0;
    for(int i=0; i<nt.brojTaaka(); z+=nt.dohvati(i++).poteg());
    z /= nt.brojTaaka();
    System.out.println("Srednje odstojanje: " + z);
  }
}
