// Definicija prozora s pomonim menijem (PomoniMeni).

import java.awt.*;
import java.awt.event.*;

public class PomoniMeni extends Frame {
  String[] izb = {"Da", "Ne", "Odustani"};       // Mogui izbori.
  
  private PomoniMeni() {                        // Parametri prozora:
    super("Pomoni meni");                       // - naslov prozora,
    setBounds(100, 100, 250, 130);               // - poloaj i veliina,
    addWindowListener(new WindowAdapter() {      // - oslukiva za dogaa-
      @Override                                  //   je prozora:
      public void windowClosing(WindowEvent dog)
        { dispose(); }                           //   ~ unitavanje prozo-
    });                                          //     ra.

    Panel plo = new Panel(null);                 // Ploa za komponente:
    add(plo);                                    //   - dodavanje prozoru.

    PopupMenu pMeni = new PopupMenu();           // Pomoni meni:
    add(pMeni);                                  // - dodavanje prozoru.

    MouseListener osl1 = new MouseAdapter() {    // Oslukiva za dogaaje
      @Override                                  //   miem:
      public void mousePressed(MouseEvent dog) { // - pritisak miem,
        Component komp = dog.getComponent();     // - pritisnuta komp.,
        if (dog.getButton()==MouseEvent.BUTTON3) // - ako je desni taster:
          pMeni.show(komp, komp.getWidth(), 0);  //   ~ prikai pomoni
      }                                          //     meni.
    };

    Button dgm = new Button(izb[0]);             // Dugme:
    dgm.setBounds(10, 10, 60, 25);               // - poloaj i veliina,
    plo.add(dgm);                                // - dodavanje ploi.
    dgm.addMouseListener(osl1);                  // - dodav. oslukivaa,
        
    ItemListener osl2 = new ItemListener() {     // Oslukiva za promene
      @Override                                  //   stavki:
      public void itemStateChanged(ItemEvent dog) {
        CheckboxMenuItem izv =                   // - stavka menija kojem
            (CheckboxMenuItem)dog.getSource();   //   je promenjeno stanje,
        dgm.setLabel(izv.getLabel());            // - novi natpis dugmeta,
        int brStav = pMeni.getItemCount();       // - broj stavki u meniju,
        for (int i=0; i<brStav; i++) {           
          CheckboxMenuItem stav = 
              (CheckboxMenuItem)pMeni.getItem(i);
          stav.setState(stav==izv);              // - samo izvorina stavka
        }                                        //   da bude potvrena.
      }
    };
    
    for (int i=0; i<izb.length; i++) {           // Stvaranje stavki:
      CheckboxMenuItem stav =                    // - sledea stavka,
          new CheckboxMenuItem(izb[i], i==0);    //   ~ prva je potvrena,
      pMeni.add(stav);                           // - dodavanje meniju,
      stav.addItemListener(osl2);                // - dodavanje oslukivaa
    }                                            //   za promene stanja.
  }

  public static void main(String[] varg)         // Glavna metoda.
    { new PomoniMeni().setVisible(true); }
}
