// Preslikavanje na platno (Preslikavanje).

import java.awt.*;
import java.awt.event.*;
import static java.lang.Math.*;

public class Preslikavanje extends Frame {
  private class Platno extends Canvas { // KLASA PLATNA:
    private double xmin=-10, xmax=10,   // Granine vrednosti logikih
                   ymin=-10, ymax=10;   //   koordinata.
    private int ir, vis;               // irina i visina platna.
    boolean verno;                      // Indikator vernog crtanja.

    private int a(double x)             // Preslikavanje koordinate x.
      { return (int)((x-xmin) / (xmax-xmin) * (ir-1)); }

    private int b(double y)             // Preslikavanje koordinate y.
      { return (int)((ymax-y) / (ymax-ymin) * (vis-1)); }

    private Platno(boolean ver)         // Konstruktor platna.
      { verno = ver; }

    @Override
    public void paint(Graphics g) {     // Metoda za crtanje:
      ir = getWidth();                 // - irina i visina platna,
      vis = getHeight();
      if (verno) {                      // - ako se trai verno crtanje:
        double q = (xmax-xmin)/(ymax-ymin)*vis/ir;
        if (q > 1) vis/=q; else ir*=q; //   ~ korekcija visine ili irine,
      }
      g.setColor(Color.RED);            // - crtanje okvira platna,
      g.drawLine(a(xmin),b(ymin),a(xmax),b(ymin));
      g.drawLine(a(xmax),b(ymin),a(xmax),b(ymax));
      g.drawLine(a(xmax),b(ymax),a(xmin),b(ymax));
      g.drawLine(a(xmin),b(ymax),a(xmin),b(ymin));
      g.setColor(Color.BLUE);
      int x1=a(0), y1=b(0);             // - poetna taka,
      double dfi= PI / 100;
      for (double fi=dfi; fi<6*PI;      // - ciklus crtanja:
                  fi+=dfi) {
        double r = 0.5 * fi;
        int x2 = a(r*cos(fi));          //   ~ sledea taka,
        int y2 = b(r*sin(fi));
        g.drawLine(x1, y1, x2, y2);     //   ~ crtanje dui,
        x1 = x2; y1 = y2;               //   ~ poetna taka za naredni
      }                                 //     prolaz kroz ciklus.
    }
  }                                     // KRAJ KLASE PLATNA

  private Preslikavanje() {                  // Parametri prozora:
    super("Preslikavanje");                  // - naslov prozora,
    setBounds(100, 100, 250, 120);           // - poloaj i veliina,
    setLayout(new GridLayout(1,2));          // - mreni rasporeiva,
    addWindowListener(new WindowAdapter() {  // - oslukiva za dogaaje
      @Override                              //   prozora:
      public void windowClosing(WindowEvent dog)
        { dispose(); }                       //   ~ unitavanju prozora,
    });
    add(new Platno(false));                  // - platno s izoblienjem,
    add(new Platno(true));                   // - platno s vernim crtanjem.
  }
  
  public static void main(String[] varg)     // Glavna metoda.
    { new Preslikavanje().setVisible(true); }
}
