// Prozor s okvirom (Prozor).

import java.awt.*;                   // Uvoenje klasa za komponente.
import java.awt.event.*;             // Uvoenje klasa za dogaaje.

public class Prozor {
  private Frame pro;                 // Objekat prozora.
  private Button dgm;                // Objekat dugmeta.
  
  private class Oslukiva           // Oslukiva za dogaaje prozora.
          extends WindowAdapter {
    @Override                        // Rukovalac dogaaja pri zatvaranju:
    public void windowClosing(WindowEvent dog) {
      pro.dispose();                 // - unitavanje prozora.
    }                                              
  }
  
  private Prozor() {                 // Konstruktor (sastavljanje prozora):
    pro = new Frame("Prozor");             // - stvaranje prozora,
    pro.setBounds(100, 100, 200, 90);      // - poloaj i veliina prozora,
    pro.setLayout(null);                   // - da bude bez rasporeivaa,
    WindowListener osl = new Oslukiva(); // - stvaranje oslukivaa,
    pro.addWindowListener(osl);            // - dodavanje oslukivaa;
    dgm = new Button("dugme");             // - stvaranje dugmeta,
    pro.add(dgm);                          // - dodavanje dugmeta prozoru,
    dgm.setBounds(70, 40, 60, 30);         // - poloaj i veliina dugmeta;
    pro.setVisible(true);                  // - neka prozor bude vidljiv.
  }
    
  public static void main(String[] varg)   // Glavna metoda:
    { new Prozor(); }                      // - stvaranje objekta Prozor.
}
