// Definicija generike klase redova objekata (Red2).

public class Red2<E> {
  protected static class Elem<T> {          // Element liste:
    T obj;                                  // - sadrani objekat,
    Elem<T> sled = null;                    // - sledei element,
    Elem(T obj) { this.obj = obj; }         // - inicijalizacija.
  }
  
  protected Elem<E> prvi=null, posl=null;   // Poetak i kraj reda (liste).
  
  public Red2<E> stavi(E obj) {             // Stavljanje na kraj rede.
    Elem<E> novi = new Elem<E>(obj);
    if (prvi == null) prvi = novi;
      else posl.sled = novi;
    posl = novi;
    return this;
  }
  
  public E uzmi() {                         // Uzimanje s poetka reda.
    if (prvi == null) {
      System.out.print("\n*** Red je prazan ***\n");
      System.exit(1);
    }
    E obj = prvi.obj;
    prvi = prvi.sled;
    if (prvi == null) posl = null;
    return obj;
  }
  
  public Red2<E> prazni()                   // Pranjenje reda.
    { prvi = posl = null; return this; }

  public boolean prazan()                   // Da li je red prazan?
    { return prvi == null; }
  
  @Override
  public String toString() {                // Tekstualni opis reda.
    var sb = new StringBuilder();
    for (Elem<E> tek=prvi; tek!=null; tek=tek.sled)
      sb.append(tek.obj).append('\n');
    return sb.toString();
  }
  
  public class Obilazak {                   // KLASA OBILAZAKA REDOVA:
    private Elem<E> tek = null;             // Tekui element obilaska.
    
    public Obilazak naPrvi()                // Poetak obilaska.
      { tek = prvi; return this; }
    
    public Obilazak naSledei() {           // Nastavak obilaska.
      if (tek != null) tek = tek.sled;
      return this;
    }
    
    public boolean imaTekui()              // Ima li tekueg elementa?
      { return tek != null; }
    
    public E tekui()                       // Dohvatanje tekueg objekta.
      { return tek!=null ? tek.obj : null; }
  }
}
