// Ispitivanje klasa proizvoaa i potroaa.

import skladite2.*;
import java.awt.*;
import java.awt.event.*;

public class Skladite2Test extends Frame {
  private final int kap = 4,                     // Parametri rada.
      brPro  = 8, minPro = 4000, maxPro = 8000,
      prPot  = 7, minPot = 3500, maxPot = 7000;

  public Skladite2Test() {                      // SASTAVLJANJE PROZORA I
    super("Proizvoai/potroai");              // INICIJALIZACIJA SISTEMA
    setBounds(100, 100, 300, 200);

    Panel ploca = new Panel(new GridLayout(1, 3));// Ploa za natpise.
    add(ploca, "North");
    ploca.add(new Label("Proizvoai:"));
    ploca.add(new Label("Skladite:"));
    ploca.add(new Label("Potroai:"));
                                                  // Ploa za podatke.
    add(ploca = new Panel(new GridLayout(1, 3)), "Center");
    Panel ploProizvoai = new Panel(new GridLayout(0, 1, 1, 1));
    TextArea tksSkladite = new TextArea();
    Panel ploPotroai = new Panel(new GridLayout(0, 1, 1, 1));
    ploca.add(ploProizvoai).setBackground(Color.BLACK);
    ploca.add(tksSkladite);
    ploca.add(ploPotroai).setBackground(Color.BLACK);
    ploca.setEnabled(false);
    
    Skladite<Integer> skladite =                // Stvaranje skladita. 
        new Skladite<Integer>(kap, tksSkladite);

    Thread[] niti = new Thread [brPro + prPot];   // Niz niti.
    int k = 0;
    
    for (int i=0; i<brPro; i++) {                 // Stvaranje proizvoaa
      Label ntp = new Label("***");
      ploProizvoai.add(ntp).setBackground(Color.WHITE);
      (niti[k++] = new Proizvoa(skladite,
                                   minPro, maxPro, ntp)).start();
    }
    
    for (int i=0; i<prPot; i++) {                 // Stvaranje potroaa.
      Label ntp = new Label("***");
      ploPotroai.add(ntp).setBackground(Color.WHITE);
      (niti[k++] = new Potroa(skladite,
                                minPot, maxPot, ntp)).start();
    }
    
    addWindowListener(new WindowAdapter() {       // Unitavanje niti i
      @Override                                   // prozora pri zatvaranju
      public void windowClosing(WindowEvent dog)  // prozora.
        { for (Thread nit: niti) nit.interrupt(); dispose(); }
    });
  }

  public static void main(String[] vpar)          // GLAVNA METODA.
    { new Skladite2Test().setVisible(true); }
}
