// Ispitivanje tipova za ureivanje nizova uporedivih objekata.

import uporedivi.*;
import ureivai.*;

public class UreivaiTest {

  // Niz za algoritme ureivanja.
  private static Ureiva[] algoritmi = 
    { new MetodaIzbora(), new MetodaUmetanja() };

  // Generator sluajnih brojeva.
  private static double slBroj(double min, double max)
    { return min + (max - min) * Math.random(); }

  // Glavna metoda.
  public static void main(String[] vpar) {
    for (Ureiva ure: algoritmi) {
      System.out.println("\n" + ure + "\n");
      
      Ceo[] ceo = new Ceo [100];
      for (int i = 0; i<ceo.length; i++) {
        System.out.print((ceo[i] = new Ceo((int)slBroj(0,10))) + " ");
        if (i % 30 == 29 || i == 99) System.out.println();
      }
      ure.uredi(ceo);
      System.out.println();
      for (int i = 0; i<ceo.length; i++) {
        System.out.print(ceo[i] + " ");
        if (i % 30 == 29 || i == 99) System.out.println();
      }
      
      Valjak[] valj = new Valjak [5];
      System.out.println();
      for (int i = 0; i<valj.length; i++)
        System.out.println((valj[i] = new Valjak(slBroj(1,3), slBroj(2,5)))
                          + " " + valj[i].V() );
      ure.uredi(valj);
      System.out.println();
      for (int i = 0; i<valj.length; i++)
        System.out.println(valj[i] + " " + valj[i].V());
      
    }
  }
}
