// Program za ispitivanje klase zbirki merljivih stvari.

import zbirka.*;

class Kocka implements Merljiv {
  double a;
  
  Kocka(double aa) { a = aa; }

  @Override
  public double veliina() { return a * a * a; }
  
  @Override
  public String toString() { return "K{" + a + "}"; }
}

class ZbirkaTest {
  public static void main(String[] varg) {
    var kocke = new Zbirka<Kocka>(5);
    try {
      for (int i=1; i<=10; i++)
        kocke.dodaj(new Kocka(i));
    } catch (GrePuna g) { System.out.println(g); }
    System.out.println("ukVel=" + kocke.ukVel() + "\n");
    
    try {
      for (int i=1; i<=10; i++) {
        Kocka kocka = kocke.uzmi(0); 
        System.out.printf("%2d %5s %10.2f\n",
            i, kocka, kocka.veliina());
      }
    } catch (GreIndeks g) { System.out.println(g); }
  }
}
