// Definicija klase za crtanje polinoma (crtanje.CrtanjePolinoma).

package crtanje;
import java.awt.*; import java.awt.event.*;

public class CrtanjePolinoma extends Frame {
  private double xmin=-10, xmax=10,      // Granine vrednosti koordinata. 
                 ymin=-10, ymax=10;
  private TextField                      // Polja za tekst za unos:
    tksXmin = new TextField(""+xmin, 3), // - graninih vrednosti
    tksXmax = new TextField(""+xmax, 3), //   koordinata,
    tksYmin = new TextField(""+ymin, 3),
    tksYmax = new TextField(""+ymax, 3),
    tksPoli = new TextField("1 1 -2 0"); // - koeficijenata polinoma.
  private Button dgmCrtaj = new Button("Crtaj"); // Komandno dugme.
  Platno platno = new Platno();          // Platno za crtanje.
  Greka greka;                         // Dijalog za poruku o greci.

  private void crtaj() {                            // Crtanje polinoma.
    try {
      double xmin = Double.parseDouble(tksXmin.getText()); // - granine
      double xmax = Double.parseDouble(tksXmax.getText()); //   vrednosti
      double ymin = Double.parseDouble(tksYmin.getText()); //   koordinata,
      double ymax = Double.parseDouble(tksYmax.getText());
      String[] s = tksPoli.getText().split(" ");    // - koeficijenti poli-
      int n=s.length-1; double[] p=new double[n+1]; //   noma,
      for (int i=0; i<=n; i++) p[n-i] = Double.parseDouble(s[i]);
      platno.crtaj(new Polinom(p), xmin, xmax, ymin, ymax);// - crtanje,
    } catch (NumberFormatException gr) {
      if (greka == null)greka = new Greka(this);
      greka.setVisible(true);                      // - poruka o greci.
    }
  }
  
  private void popuniProzor() {          // Popunjavanje prozora.
    add(platno, "Center");
    Panel plo = new Panel(new BorderLayout()); add(plo, "North");
    plo.add(new Label("poli:", Label.RIGHT), "West");
    plo.add(tksPoli, "Center"); plo.add(dgmCrtaj, "East");
    dgmCrtaj.addActionListener(new ActionListener() {
      @Override
      public void actionPerformed(ActionEvent dog) { crtaj(); }
    });
    add(plo = new Panel(), "South");
    plo.add(new Label("x:", Label.RIGHT));
    plo.add(tksXmin); plo.add(tksXmax);
    plo.add(new Label("y:", Label.RIGHT));
    plo.add(tksYmin); plo.add(tksYmax);
    crtaj();
  }
  
  public CrtanjePolinoma() {                        // Inicijalizacija.
    super("Polinom"); setSize(300, 200);
    addWindowListener(new WindowAdapter() {
      @Override
      public void windowClosing(WindowEvent dog) { dispose(); }
    });
    popuniProzor(); setVisible(true);
  }
  
  public static void main(String[] varg)            // Glavna metoda.
    { new CrtanjePolinoma(); }
}
