// Definicija klase platna (crtanje.Platno).

package crtanje;
import java.awt.*;

public class Platno extends Canvas {
  private int ir, vis;                   // irina i visina platna.
  private double xmin, xmax, ymin, ymax;  // Granine vrednosti koordinata.
  private Fun fun;                        // Funkcija koja se crta.
  
  private int a(double x)                 // Preslikavanje koordinate x.
    { return (int)((x-xmin) / (xmax-xmin) * (ir-1)); }

  private int b(double y)                 // Preslikavanje koordinate y.
    { return (int)((ymax-y) / (ymax-ymin) * (vis-1)); }
  
  public void crtaj(Fun f, double x1, double x2,     // Zahtev za crtanje.
                           double y1, double y2) {
    fun = f; xmin = x1; xmax = x2; ymin = y1; ymax = y2;
    repaint();
  }
  
  @Override
  public void paint(Graphics g) {         // Crtanje krive:
    ir = getWidth(); vis = getHeight();  // - dimenzije platna,
    g.setColor(new Color(240, 240, 240)); // - popunjavanje podloge,
    g.fillRect(0, 0, ir, vis);
    g.setColor(Color.RED);                // - crtanje koordinatnih osa,
    g.drawLine(a(xmin),  b(0), a(xmax), b(0));
    g.drawLine(a(0), b(ymin), a(0), b(ymax));
    g.setColor(Color.BLACK);              // - crtanje funkcije,
    int a1 = a(xmin), b1 = b(fun.f(xmin));
    double dx = (xmax - xmin) / 300;
    boolean prva = true;
    for (double x=xmin+dx; x<=xmax; x+=dx) {
      double y = fun.f(x);
      if (!Double.isNaN(y)) {
        int a2 = a(x), b2 = b(y);
        if (!prva) g.drawLine(a1, b1, a2, b2); else prva = false;
        a1 = a2; b1 = b2;
      } else prva = true;
    }
  }
}
