// Definicija klase trouglova u ravni (figure.Trougao).

package figure;
import ravan.Taka;

public class Trougao extends Figura {
  private double a, b, c;                           // Stranice.

  public Trougao()          { super(); a=b=c=1;  }  // Inicijalizacija.
  public Trougao(double aa) { super(); a=b=c=aa; }
  public Trougao(double aa, double bb)
    { super();   a = aa; b = c = bb; }
  public Trougao(double aa, double bb, double cc)
    { super();   a = aa; b = bb; c = cc; }
  public Trougao(double aa, double bb, double cc, Taka TT)
    { super(TT); a = aa; b = bb; c = cc; }

  @Override
  public double O() { return a + b + c; }           // Obim.

  @Override
  public double P() {                               // Povrina.
    double s = (a + b + c) / 2;
    return Math.sqrt(s * (s-a) * (s-b) * (s-c));
  }

  @Override
  public String toString() {                        // Tekstualni opis.
    return "troug[" + super.toString() + ", a=" + a + ", b=" + b +
      ", c=" + c + ", O=" + O() + ", P=" + P() + "]";
  }
}
