// Definicija klase za pilove karata za igru (karte.pil).

package karte;

public class pil {
  private Karta[] karte;                       // Niz karata.
  private int brKarata = 0;                    // Broj karata.
  private int tek = 0;                         // Tekua karta za uzimanje.

  public pil() {                              // Inicijalizacija:     
    karte = new Karta[Boja.values().length * Vrednost.values().length];
    for (var boja: Boja.values())                 // - za svaku boju i
      for (var ozn: Vrednost.values())            //   sve vrednosti
        karte[brKarata++] = new Karta(boja, ozn); //   po jedna karta.
  }

  public void meaj() {                           // Meanje pila.
    for (int i=0; i<brKarata; i++) {
      int j = (int)(Math.random()*brKarata);
      Karta k = karte[i]; karte[i] = karte[j]; karte[j] = k;
    }
    tek = 0;
  }
  
  public Karta uzmi() throws GreNemaVieKarata {        // Uzimanje sledee
    if (tek == brKarata) throw new GreNemaVieKarata(); //   karte.
    return karte[tek++];
  }
    
  public boolean imaJo()                         // Ima li jo karata
    { return tek < brKarata; }                    //   za uzimanje?
  
  @Override                                       // Tekstualni opis
  public String toString() {                      //   (samo jo neuzete
    var sb = new StringBuilder();       //    karte).
    for (int i=tek, j = 0; i<brKarata; i++, j++)
      sb.append(karte[i]).append(j%13==12 ? "\n" : " ");
    return sb.toString();
  }
}
