// Definicija generike klase nizova figura (nizFigura.NizFigura).

package nizFigura;
import java.util.Iterator;
import java.util.NoSuchElementException;
import figure.Figura;

public class NizFigura<E extends Figura> implements Iterable<E> {
  private E[] niz;                               // Sadrani niz.
  private int du = 0;                           // Broj popunjenih mesta.
  
  @SuppressWarnings("unchecked")
  public NizFigura(int kap)                      // Stvaranje objekta.
    { niz = (E[]) new Figura [kap]; }
  public NizFigura() { this(10); }
  
  public NizFigura<E> dodaj(E e) throws GreNizPun { // Dodavanje figure.
    if (du == niz.length) throw new GreNizPun();
    niz[du++] = e; return this;
  }
  
  public E dohvati(int ind) throws GreIndeks {      // Dohvatanje figure.
    if (ind<0 || ind>=du) throw new GreIndeks();
    return niz[ind];
  }

  @Override
  public Iterator<E> iterator()                  // Stvaranje iteratora.
    { return new Iter(); }
  
  private class Iter implements Iterator<E> {    // Klasa iteratora:
    private int tek = 0;                         // - indeks tekueg elem.

    @Override
    public boolean hasNext() { return tek<du; } // - ima li sledeeg?

    @Override
    public E next() throws NoSuchElementException { // - sledei element.
      if (tek == du) throw new NoSuchElementException();
      return niz[tek++];
    }
  } // class Iter

  @Override
  public String toString() {                     // Tekstualni opis niza.
    var sb = new StringBuilder();
    for (E e: this) sb.append(e).append('\n');
    return sb.toString();
  }

  public double ukP()                      // Ukupna povrina figura.
    { double P = 0; for (E e: this) P += e.P(); return P; }

  public int broj(Uslov<E> u)              // Broj odgovarajuih elemenata.
    { int n = 0; for (E e: this) if (u.uslov(e)) n++; return n; }
  
  public NizFigura<E> uredi(Uporedi<E> u) {       // Ureivanje niza.
    for (int i=0; i<du-1; i++)
      for (int j=i+1; j<du; j++)
        if (u.ispred(niz[j], niz[i]))
            { E e = niz[i]; niz[i] = niz[j]; niz[j] = e; }
    return this;
  }
}
