// Definicija klase sklopova predmeta (predmeti.Sklop).

package predmeti;

public class Sklop extends Predmet {

  private class Elem {                      // Element liste:
    Predmet pr; Elem sled = null;           // - predmet i sledei element,
    Elem(Predmet p) {                       // - inicijalizacija.
      pr = p;
      if (prvi == null) prvi = this; else posl.sled = this;
      posl = this;
    }
  }
  
  private Elem prvi = null, posl = null;

  public Sklop dodaj(Predmet p)             // Dodavanje predmeta.
    { new Elem(p); return this; }

  @Override
  public final double V() {                 // Zapremina sklopa.
    double V = 0;
    for (Elem tek=prvi; tek!=null; tek=tek.sled) V += tek.pr.V();
    return V;
  }

  @Override
  public final double Q() {                 // Teina sklopa.
    double Q = 0;
    for (Elem tek=prvi; tek!=null; tek=tek.sled) Q += tek.pr.Q();
    return Q;
  }

  @Override
  public Sklop clone() {                    // Kloniranje.
    Sklop s = (Sklop)super.clone();
    s.prvi = s.posl = null;
    for (Elem tek=prvi; tek!=null; tek=tek.sled)
      s.new Elem(tek.pr.clone());
    return s;
  }

  private static int nivo = 0;                  // Nivo uklapanja predmeta.

  private static void uvuci(StringBuilder sb) { // Uvlaenje ugneenih
    for (int i=0; i<nivo; i++) sb.append("  "); //   predmeta u tekstu-
  }                                             //   alnom opisu.

  @Override
  public String toString() {                    // Tekstualni opis.
    var sb = new StringBuilder();
    sb.append(super.toString()).append(" {\n");
    nivo++;
    for (Elem tek=prvi; tek!=null; tek=tek.sled)
      { uvuci(sb); sb.append(tek.pr).append('\n'); }
    nivo--;
    uvuci(sb); return sb.append('}').toString();
  }
}
