// Definicija klase ravni s obojenim krugovima (ravan.Ravan).

package ravan;

class Elem {                  // Element liste:
  Krug krug;                  // - sadrani krug,
  Elem preth, sled;           // - prethodni i sledei element liste,
  Elem (Krug k, Elem p)       // - inicijalizacija elementa.
    { krug = k; preth = p; }
}

public class Ravan {
  private Elem prvi, posl;    // Poetak i kraj liste krugova.
  
  private Boja podl;          // Boja podloge.
                                           // Inicijalizacija ravni:
  public Ravan(Boja b) { podl = b; }       // - zadatom bojom podloge,
  public Ravan() { podl = new Boja(); }    // - belom bojom podloge.
  
  public Ravan dodaj(Krug k) {             // Dodavanje kruga u ravan.
    Elem novi = new Elem(k, posl);
    if (prvi == null) prvi = novi;
      else posl.sled = novi;
    posl = novi;
    return this; 
  }
  
  public Boja boja(Taka T) {              // Boja zadate take u ravni.
    for (Elem tek=posl; tek!=null; tek=tek.preth)
      if (tek.krug.pripada(T)) return tek.krug.boja();
    return podl;
  }
  
  public String toString() {               // Tekstualni opis ravni.
    var sb = new StringBuilder();
    for (Elem tek=prvi; tek!=null; tek=tek.sled)
      sb.append(tek.krug).append('\n');
    return sb.toString();
  }
}
