// Definicija klase za uskladitavanje podataka (skladite2.Skladite).

package skladite2;
import java.awt.TextArea;

public class Skladite<P> {
  private static int posId = 0;  // Poslednji identifikator.
  private int id = ++posId;      // Identifikator skladita.
  private P[] niz;               // Niz za uskladitavanje proizvoda.
  private int ulaz=0, izlaz=0;   // Mesto stavljanja i uzimanja podatka.
  private int pun = 0;           // Broj popunjenih mesta.
  private TextArea prik;         // Prikaziva sadraja skladita.
  
  @SuppressWarnings("unchecked")
  public Skladite(int kap, TextArea pri)     // Inicijalizacija.
    { niz = (P[])new Object [kap]; prik = pri;}

  public int id() { return id; }              // Dohvatanje identifikatora.

  public synchronized void stavi(P pro) throws InterruptedException {
    while (pun == niz.length) wait();         // Stavljanje proizvoda.
    niz[ulaz++] = pro;
    if (ulaz == niz.length) ulaz = 0;
    pun++;
    prik.setText(toString());
    notifyAll();
  }
                                              // Uzimanje Proizvoda.
  public synchronized P uzmi() throws InterruptedException {
    while (pun == 0) wait();
    P pro = niz[izlaz]; niz[izlaz++] = null;
    if (izlaz == niz.length) izlaz = 0;
    pun--;
    prik.setText(toString());
    notifyAll();
    return pro;
  }
  
  @Override
  public synchronized String toString() {     // Tekstualni opis
    var sb = new StringBuilder();
    for (int i=0; i<pun; i++)
      sb.append(niz[(izlaz+i) % niz.length]).append('\n');
    return sb.toString();
  }
}
