// Definicija klase zbirke merljivih stvari (zbirka.Zbirka).

package zbirka;

public class Zbirka<E extends Merljiv> {
  Merljiv[] mer;                               // Sadraj zbirke.
  int du = 0;                                 // Broj stvari u zbirci.
  
  public Zbirka(int kap)                       // Inicijalizacija.
    { mer = new Merljiv [kap]; }
  
  public Zbirka<E> dodaj(E e) throws GrePuna { // Dodavanje stvari.
    if (du == mer.length) throw new GrePuna();
    mer[du++] = e;
    return this;
  }

  @SuppressWarnings("unchecked")
  public E uzmi(int ind) throws GreIndeks {    // Uzimanje stvari.
    if (ind<0 || ind>=du) throw new GreIndeks();
    Merljiv e = mer[ind]; du--;
    for (int i=ind; i<du; mer[i++]=mer[i]);
    mer[du] = null;
    return (E)e;
  }
  
  private static class Odredi                  // Nit za odreivanje
                 extends Thread {              //   veliine jedne stvari:
    Merljiv m;                                 // - obraivana stvar,
    double v;                                  // - rezultat obrade,
    Odredi(Merljiv mm) { m = mm; }             // - inicijalizacija,
    @Override
    public void run() { v = m.veliina(); }    // - obrada,
    double rez() { return v; }                 // - dohvatanje rezultata.
  }

  public double ukVel() {       // Odreivanje ukupne veliine svih stvari:
    Odredi[] odr = new Odredi [du];           // - niz niti,
    for (int i=0; i<du; i++)                  // - stvaranje i pokretanje
      (odr[i] = new Odredi(mer[i])).start();   //   niti,
    double uv = 0;
    try {
      for (int i=0; i<du; i++) {              // - prikupljanje rezultata
         odr[i].join();                        //   (ekanje kraja niti)
         uv += odr[i].rez();                   //   (dohvatanje rezultata).
      }
    } catch (InterruptedException g) {}
    return uv;
  }
}
